import BaseLayer from '../../core/BaseLayer';
import { ILineLayerStyleOptions, IPointLayerStyleOptions, IPolygonLayerStyleOptions } from '../../core/interface';
import lineFillModel from '../../line/models/tile';
import pointTextModel from '../../point/models/text';
import pointFillModel from '../../point/models/tile';
import polygonFillModel from '../../polygon/models/tile';
export default class VectorLayer extends BaseLayer<Partial<IPolygonLayerStyleOptions & ILineLayerStyleOptions & IPointLayerStyleOptions>> {
    isVector: boolean;
    type: string;
    private pickedID;
    getPickID(): number | null;
    setPickID(): number | null;
    buildModels(): void;
    rebuildModels(): void;
    protected getModelType(): typeof lineFillModel | typeof pointTextModel | typeof pointFillModel | typeof polygonFillModel;
    protected getPointModel(): typeof pointTextModel | typeof pointFillModel;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {};
}
